<?php
if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

    $inDB   = cmsDatabase::getInstance();
    $inCore = cmsCore::getInstance();
    $inCore->loadModel('sanction');
    $model = new cms_model_sanction();

    $opt = $inCore->request('opt', 'str', 'list');
    $id  = $inCore->request('id', 'int', 0);
    
    $cfg = $inCore->loadComponentConfig('sanction');

    cpAddPathway('Санкции и штрафы', '?view=components&do=config&id='.$id);

//============================================================================//
//============================================================================//

	$toolmenu = array();

	if($opt != 'config'){
            $toolmenu[10]['icon'] = 'user_imprisoned.png';
            $toolmenu[10]['title'] = 'Список ограниченных пользователей';
            $toolmenu[10]['link'] = '?view=components&do=config&id='.$id.'&opt=list';
            
            $toolmenu[20]['icon'] = 'page_white_error.png';
            $toolmenu[20]['title'] = 'Список выданных предупреждений';
            $toolmenu[20]['link'] = '?view=components&do=config&id='.$id.'&opt=list_notice';
            
            $toolmenu[40]['icon'] = 'config.gif';
            $toolmenu[40]['title'] = 'Настройки';
            $toolmenu[40]['link'] = '?view=components&do=config&id='.$id.'&opt=config';
            
            cpToolMenu($toolmenu);
	}

	if($opt == 'config'){
		$toolmenu[16]['icon'] = 'save.gif';
		$toolmenu[16]['title'] = 'Сохранить';
		$toolmenu[16]['link'] = 'javascript:document.optform.submit();';

		$toolmenu[17]['icon'] = 'cancel.gif';
		$toolmenu[17]['title'] = 'Отмена';
		$toolmenu[17]['link'] = '?view=components&do=config&id='.$id;
                
		cpToolMenu($toolmenu);
	}

//============================================================================//
//============================================================================//

    if ($opt == 'list'){
        $page    = $inCore->request('page', 'int', 1);
        $perpage = 30;

	$total = $model->getCountSanctions();
        $inDB->limitPage($page, $perpage);

        $sanctions = $model->getSanctions();
	$pagebar = cmsPage::getPagebar($total, $page, $perpage, '?view=components&do=config&id='.$id.'&opt=list&page=%page%');
                
        echo '<h3>Список выданных санкций</h3>';
        if ($sanctions) { ?>
            <table class="tablesorter">
                <thead>
                    <tr>
                        <th class="lt_header" width="25">id</th>
                        <th class="lt_header" width="90">Пользователь</th>
                        <th class="lt_header" width="90">Выдал</th>
                        <th class="lt_header">Причина</th>
                        <th class="lt_header">Санкции</th>
                        <th class="lt_header" width="90">Дата</th>
                        <th class="lt_header" width="200">Истекает</th>
                        <th class="lt_header" align="center" width="70">Действия</th>
                    </tr>
                </thead>
                <?php foreach($sanctions as $key => $sanction) { ?>
                <tbody>
                    <tr>
                        <td><?php echo $key; ?></td>
                        <td><?php echo $sanction['user']['link']; ?></td>
                        <td><?php echo $sanction['who_gave']['link']; ?></td>
                        <td><?php echo $sanction['reason']; ?></td>
                        <td><?php echo $sanction['access']; ?></td>
                        <td><?php echo $sanction['datef']; ?></td>
                        <td><?php echo $sanction['time_left']; ?></td>
                        <td align="right">
                          <div style="padding-right: 8px;">
                            <a title="Редактировать" href="?view=components&do=config&id=30&opt=edit_sanction&edit_id=<?php echo $key; ?>"><img border="0" hspace="2" alt="Редактировать" src="/admin/images/actions/edit.gif"></a>
                            <a href="/sanction/delete/<?php echo $key; ?>" title="Удалить" onclick="if(!confirm('Удалить ограничение для <?php echo $sanction['user']['nickname']; ?>?')){ return false; }"><img border="0" hspace="2" alt="Удалить" src="/admin/images/actions/delete.gif"></a>
                          </div>
                        </td>
                    </tr>
                </tbody>
                <?php } ?>
            </table>
        <?php
	if($pagebar) { echo $pagebar; }
	} else { echo '<p>Санкций не найдено</p>'; }

    }

//============================================================================//
//============================================================================//

    if ($opt == 'list_notice'){
        $page    = $inCore->request('page', 'int', 1);
        $perpage = 30;

	$total = $model->getCountNotices();
        $inDB->limitPage($page, $perpage);

        $notices = $model->getNotices();
	$pagebar = cmsPage::getPagebar($total, $page, $perpage, '?view=components&do=config&id='.$id.'&opt=list&page=%page%');
                
        echo '<h3>Список выданных предупреждений</h3>';
        if ($notices) { ?>
            <table class="tablesorter">
                <thead>
                    <tr>
                        <th class="lt_header" width="25">id</th>
                        <th class="lt_header" width="90">Пользователь</th>
                        <th class="lt_header" width="90">Выдал</th>
                        <th class="lt_header">Причина</th>
                        <th class="lt_header" width="90">Дата</th>
                        <!--th class="lt_header" align="center" width="70">Действия</th-->
                    </tr>
                </thead>
                <?php foreach($notices as $key => $notice) { ?>
                <tbody>
                    <tr>
                        <td><?php echo $key; ?></td>
                        <td><?php echo $notice['user']['link']; ?></td>
                        <td><?php echo $notice['who_gave']['link']; ?></td>
                        <td><?php echo $notice['reason']; ?></td>
                        <td><?php echo $notice['datef']; ?></td>
                        <!--td align="right">
                          <div style="padding-right: 8px;">
                            <a title="Редактировать" href="?view=components&do=config&id=30&opt=edit_sanction&edit_id=<?php echo $key; ?>"><img border="0" hspace="2" alt="Редактировать" src="/admin/images/actions/edit.gif"></a>
                            <a href="/sanction/delete/<?php echo $key; ?>" title="Удалить" onclick="if(!confirm('Удалить ограничение для <?php echo $notice['user']['nickname']; ?>?')){ return false; }"><img border="0" hspace="2" alt="Удалить" src="/admin/images/actions/delete.gif"></a>
                          </div>
                        </td-->
                    </tr>
                </tbody>
                <?php } ?>
            </table>
        <?php
	if($pagebar) { echo $pagebar; }
	} else { echo '<p>Санкций не найдено</p>'; }

    }

//============================================================================//
//============================================================================//

if($opt=='saveconfig'){

    if(!cmsCore::validateForm()) { cmsCore::error404(); }

    $cfg = array();

    $cfg['rezhim']              = $inCore->request('rezhim', 'int', 1);
    $cfg['send_notify']         = $inCore->request('send_notify', 'int', 1);
    $cfg['see_rz1_always']      = $inCore->request('see_rz1_always', 'array_int', array());
    $cfg['see_sanctions']       = $inCore->request('see_sanctions', 'array_int', array());
    $cfg['can_give_my_group']   = $inCore->request('can_give_my_group', 'int', 0);
    $cfg['rz1']                 = $inCore->request('rz1', 'array', array());
    $cfg['rz2']                 = $inCore->request('rz2', 'array', array());
    
    $i = 1;
    foreach($cfg['rz2']['chain']['time'] as $key => $value){
        $cfg['rz2']['chain']['lvl'.$i] = $value ? array('access'=>$cfg['rz2']['chain']['access'][$key],'time'=>$value) :  array('access'=>'','time'=>'');
        $i++;
    }
        unset($cfg['rz2']['chain']['access']);
        unset($cfg['rz2']['chain']['time']);

    $inCore->saveComponentConfig('sanction', $cfg);

    cmsCore::addSessionMessage('Настройки успешно сохранены', 'success');

    cmsUser::clearCsrfToken();

    $inCore->redirect('?view=components&do=config&id='.$id.'&opt=config');

}
//============================================================================//
//============================================================================//
if ($opt=='config') {

    cpAddPathway('Настройки', '?view=components&do=config&id='.$id.'&opt=config');

    require('../includes/jwtabs.php');
    $GLOBALS['cp_page_head'][] = jwHeader();

    ?>
    <form action="index.php?view=components&amp;do=config&amp;id=<?php echo $id;?>" method="post" name="addform" target="_self" id="optform" style="margin-top:10px">
    <input type="hidden" name="csrf_token" value="<?php echo cmsUser::getCsrfToken(); ?>" />
        <?php ob_start(); ?>
       {tab=Общие}
       <table width="609" border="0" cellpadding="10" cellspacing="0" class="proptable">
            <tr>
                <td colspan="2" valign="top" bgcolor="#EBEBEB"><h4>Режимы</h4></td>
            </tr>
            <tr>
                <td valign="top"><strong>Режим работы:</strong><br />
                    <span class="hinttext">1 - штрафы: модератор вручную назначает меру пресечения и срок;<br />
                    2 - линейка: модератор выдаёт предупреждение, каждый уровень карается установленными санкциями.</span></td>
                <td valign="top">
                    <select name="rezhim" style="width:200px">
                        <option value="1" <?php if($cfg['rezhim']==1) { echo 'selected'; } ?>>Режим 1 (штрафы)</option>
                        <option value="2" <?php if($cfg['rezhim']==2) { echo 'selected'; } ?>>Режим 2 (линейка)</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td valign="top"><strong>Режим 1 всегда доступен:</strong><br />
                    <span class="hinttext">Вне зависимости от выбранного режима, они всегда смогут выдать штрафную санкцию.</span></td>
                <td valign="top">
                  <div style="margin-top:10px;padding:5px;padding-right:0px;">
                      <div>
                          <?php
                          $groups = cmsUser::getGroups();
                          $access_list = $cfg['see_rz1_always'];
                              echo '<select style="width: 245px" name="see_rz1_always[]" id="see_rz1_always" size="6" multiple="multiple">';
                              echo '<option value=""';
                              if (!$access_list[0])echo ' selected';
                              echo '>Никому</option>';
                                if ($groups){
                                    foreach($groups as $group){
                                        if($group['alias'] != 'guest'){
                                            echo '<option value="'.$group['id'].'"';
                                            if ($access_list){
                                                if (inArray($access_list, $group['id']))echo 'selected';
                                            }
                                            echo '>';
                                            echo $group['title'].'</option>';
                                            $groups_with_admin[] = $group;
                                        }
                                    }
                                }
                              echo '</select>';
                          ?>
                      </div>
                  </div>
               </td>
            </tr>
            <tr>
                <td valign="top"><strong>Отправлять оповещения:</strong><br />
                    <span class="hinttext">Высылать юзеру оповещение о выданном предупреждении или штрафной санкции.</span></td>
                <td valign="top">
                    <label><input name="send_notify" type="radio" value="1" <?php if ($cfg['send_notify']) { echo 'checked="checked"'; } ?> /> Да</label>
                    <label><input name="send_notify" type="radio" value="0" <?php if (!$cfg['send_notify']) { echo 'checked="checked"'; } ?>/> Нет</label>
                </td>
            </tr>
            <tr>
                <td colspan="2" valign="top" bgcolor="#EBEBEB"><h4>Управление</h4></td>
            </tr>
            <tr>
                <td valign="top"><strong>Выдавать, редактировать и удалять санкции родственникам по группе:</strong></td>
                <td valign="top">
                    <label><input name="can_give_my_group" type="radio" value="1" <?php if ($cfg['can_give_my_group']) { echo 'checked="checked"'; } ?> /> Да</label>
                    <label><input name="can_give_my_group" type="radio" value="0" <?php if (!$cfg['can_give_my_group']) { echo 'checked="checked"'; } ?>/> Нет</label>
                </td>
            </tr>
            <tr>
                <td valign="top"><strong>Группы, которые могут управлять санкциями:</strong><br />
                    <span class="hinttext">Данные группы получают доступ к разделу "/sanction/", видят кнопку и вкладку в профиле пользователя. Администрация всегда имеет доступ.</span></td>
                <td valign="top">
                    <div style="margin-top:10px;padding:5px;padding-right:0px;">
                      <div>
                          <?php
                          $access_list = $cfg['see_sanctions'];
                              echo '<select style="width: 245px" name="see_sanctions[]" id="see_sanctions" size="6" multiple="multiple">';
                              echo '<option value=""';
                              if (!$access_list[0])echo ' selected';
                              echo '>Только администрация</option>';
                                if ($groups){
                                    foreach($groups as $group){
                                        if($group['alias'] != 'guest' && !$group['is_admin']){
                                            echo '<option value="'.$group['id'].'"';
                                            if ($access_list){
                                                if (inArray($access_list, $group['id']))echo ' selected';
                                            }
                                            echo '>';
                                            echo $group['title'].'</option>';
                                        }
                                    }
                                }
                              echo '</select>';
                          ?>
                      </div>
                  </div>
                </td>
            </tr>
       </table>
       {tab=Режим 1}
       <table width="800" border="0" cellpadding="10" cellspacing="0" class="proptable">
            <tr>
                <td colspan="2" valign="top" bgcolor="#EBEBEB"><h4>Настройки</h4></td>
            </tr>
            <tr>
                <td valign="top">
                    <strong>Максимальное время:</strong><br />
                    <span class="hinttext">На какое максимальное кол-во минут модератор может выдать санкцию.
                    Администрация выдаёт без ограничений.</span>
                </td>
                <td valign="top"><input name="rz1[max_mins]" type="text" id="max_mins" value="<?php echo $cfg['rz1']['max_mins'];?>" size="6" /> мин.</td>
            </tr>
            <tr>
                <td colspan="2" valign="top" bgcolor="#EBEBEB"><h4>Доступ</h4></td>
            </tr>
            <tr>
                <td colspan="2" valign="top"><strong>Кто и на что может выдавать ограничения:</strong><br />
                    <span class="hinttext">Выдать ограничение на то, что не доступно группе преступника, никто не сможет.</span>
                </td>
            </tr>
            <tr>
                <td colspan="2" valign="top">
                    <table id="access_tbl">
                        <tr style="overflow:hidden;height:100px">
                            <td>&nbsp;</td>
                        <?php
                                if ($groups_with_admin){
                                    foreach($groups_with_admin as $group){
                                            echo '<td><div class="rotatedBlock">'.$group['title'].'</div></td>';
                                    }
                                }
                          ?>
                        </tr>
                        <?php
                                $result = $inDB->query("SELECT * FROM cms_user_groups_access ORDER BY `access_type` ASC");
                                if($inDB->num_rows($result)){
                                    while($type = $inDB->fetch_assoc($result)){
                                        $access_types[$type['access_name']] = $type['access_type'];
                                    }
                                }
                                if ($groups_with_admin && $access_types){
                                    foreach($access_types as $name => $type){
                                        echo '<tr><td>'.$name.'</td>';
                                        foreach($groups_with_admin as $group){
                                                echo '<td align="center"><input name="rz1[access]['.$group['id'].']['.$type.']" type="checkbox" value="1"'.($cfg['rz1']['access'][$group['id']][$type] ? ' checked="checked"' : '').'></td>';
                                        }
                                        echo '</tr>';
                                    }
                                }
                          ?>
                    </table>
                </td>
            </tr>
       </table>
       <style>
           .rotatedBlock {
            -moz-transform: rotate(-90deg);
            -webkit-transform: rotate(-90deg);
            -o-transform: rotate(-90deg);
            -ms-transform: rotate(-90deg);
            transform: rotate(-90deg);
            }
            #access_tbl { 
            width: 100%;
            border-collapse: collapse;
            border: 1px solid #EBEBEB;
            }
            #access_tbl td { 
            padding: 5px;
            border: 1px solid #EBEBEB;
            }
       </style>
       {tab=Режим 2}
       <table width="609" border="0" cellpadding="10" cellspacing="0" class="proptable">
            <tr>
                <td colspan="2" valign="top" bgcolor="#EBEBEB"><h4>Настройки</h4></td>
            </tr>
            <tr>
                <td valign="top">
                    <strong>Промежуток между предупреждениями:</strong><br />
                    <span class="hinttext">Через сколько минут можно снова давать предупреждение одному и тому же юзеру.</span>
                </td>
                <td valign="top"><input name="rz2[between_notify]" type="text" id="max_mins" value="<?php echo $cfg['rz2']['between_notify'];?>" size="6" /> мин.</td>
            </tr>
            <tr>
                <td valign="top">
                    <strong>Промежуток между предупреждениями для модератора:</strong><br />
                    <span class="hinttext">Через сколько минут <b>модератор</b> снова сможет дать предупреждение одному и тому же юзеру.</span>
                </td>
                <td valign="top"><input name="rz2[between_notify_for_one]" type="text" id="max_mins" value="<?php echo $cfg['rz2']['between_notify_for_one'];?>" size="6" /> мин.</td>
            </tr>
<!--           <tr>
                <td valign="top">
                    <strong>Модераторы:</strong><br />
                    <span class="hinttext">Группы пользователей, имеющих право выдавать предупреждения.</span>
                </td>
                <td valign="top">-->
                    <?php
//                          $access_list = $cfg['rz2']['groups'];
//                              echo '<select style="width: 245px" name="rz2[groups][]" size="6" multiple="multiple">';
//                                if ($groups){
//                                    foreach($groups as $group){
//                                        if($group['alias'] != 'guest' && !$group['is_admin']){
//                                            echo '<option value="'.$group['id'].'"';
//                                            if ($access_list){
//                                                if (inArray($access_list, $group['id']))echo ' selected';
//                                            }
//                                            echo '>';
//                                            echo $group['title'].'</option>';
//                                        }
//                                    }
//                                }
//                              echo '</select>';
                          ?>
<!--                </td>
            </tr>
            <tr>-->
                <td colspan="2" valign="top">
                    <strong>Линейка (цепочка) уровней предупреждений:</strong><br />
                    <span class="hinttext">Список санкций и время для этой строки может быть пустым.<br />
                    Время - это кол-во минут на выданные санкции, при достижении данного уровня.
                    При этом все вышележащие санкции также будут задействованы.<br />
                    Список санкций разделяется запятыми.</span>
                </td>
            </tr>
            <tr>
                <td colspan="2" valign="top">
                    <div style="padding:5px;background:#ECECEC;margin-top:10px;margin-bottom:10px;margin-right:0px;">
                      <table border="0" cellpadding="5" cellspacing="0" width="100%" id="lvls">
                          <tr>
                            <th width="30">Уровень</th>
                            <th>Список санкций</th>
                            <th width="50">Время (минут)</th>
                            <th>&nbsp;</th>
                          </tr>
                          <?php
                            if ($cfg['rz2']['chain']){
                                foreach($cfg['rz2']['chain'] as $lvl => $value){
                          ?>
                          <tr class="lvl">
                              <th><?php echo str_replace('lvl', '', $lvl); ?></th>
                            <td><input type="text" name="rz2[chain][access][]" style="width:99%" value="<?php echo $value['access']; ?>"></td>
                            <td><input type="text" name="rz2[chain][time][]" size="8" value="<?php echo $value['time']; ?>"></td>
                            <td width="17" class="lvl_del">
                              <a href="#" onclick="delLvl(this);return false;" title="Удалить уровень" style="display: none;">
                                <img src="/admin/images/actions/delete.gif" alt="Удалить уровень" border="0">
                              </a>
                            </td>
                          </tr>
                          <?php
                                    }
                                }
                          ?>
                      </table>
                      <script type="text/javascript">
                            function addLvl(){
                                var lvl = $('#lvls .lvl:first').clone();
                                lvl.find('input').val('');
                                $('#lvls').append(lvl);
                                recountLvls();
                                return false;
                            }
                            function delLvl(elem){
                                var count = $('#lvls .lvl').length;
                                if(count<2)return false;
                                $(elem).parent().parent().remove();
                                recountLvls();
                                return false;
                            }
                            function recountLvls(){
                                var nmb = 1;
                                var count = $('#lvls .lvl').length;
                                $('#lvls .lvl').each(function(){
                                    $(this).find('th').text(nmb);
                                    if(nmb==1 && count<2)$(this).find('.lvl_del a').hide();
                                    else $(this).find('.lvl_del a').show();
                                    nmb++;
                                });
                            }
                            recountLvls();
                     </script>
                      <div style="margin:5px;margin-bottom:10px;">
                        <a href="#" onclick="addLvl();return false;">Добавить уровень</a>
                      </div>
                    </div>
                </td>
            </tr>
            <tr>
                <td colspan="2" valign="top">
                    <span class="hinttext">
                    <strong>Возможные значения</strong>:
                    <table>
                    <?php
                        if ($access_types){
                            foreach($access_types as $name => $type){
                                echo '<tr><td>'.$name.'</td><td><b>'.$type.'</b></td></tr>';
                            }
                        }
                    ?>
                    </table>
                    </span>
                </td>
            </tr>
        </table>
        {/tabs}
        <?php echo jwTabs(ob_get_clean()); ?>
        <p>
            <input name="opt" type="hidden" id="do" value="saveconfig" />
            <input name="save" type="submit" id="save" value="Сохранить" />
        </p>
    </form>
    <?php
 }
 //============================================================================//
//============================================================================//